#ifndef AP238_H
#define AP238_H

// Set these to 1 if tracing files should be made in main program - tracing files go to same directory as stepnc export
#define NEED_MC_TRACE_FILE  1			// set to 1 to turn on, 0 to turn off
#define NEED_AP238_TRACE_FILE  1		// set to 1 to turn on, 0 to turn off	

// For finer control mess with these macros - Errors can be reported to a message box, a trace file, both or neither
#ifndef EXPORT_REPORT
#define EXPORT_REPORT
#define MC_REPORT(...) ap238export_report_error(__VA_ARGS__)			
#endif

// For finer control mess with these macros - Tracing of function calls can be eliminated by selecting appropriate definition for MC_TRACE
#ifndef EXPORT_TRACE
#define EXPORT_TRACE
#ifndef MC_TRACE	// select one
#define MC_TRACE ap238_function_trace	// include tracing code in system
//#define MC_TRACE(...)			// omit tracing code from system
#endif
#endif

// STIX defines functions to handle units and other useful utilities
#include <stp_schema.h>
#include <stix.h>

// ARM defines all the Application Objects in the ARM library (long list)
#include "ARM.h"

// File used by all the makers for tracing - must be defined in main program
extern FILE *mcLog;

// function calls are sent to a trace file or eliminated from code by choosing appropriate define for TRACE_FILE
void ap238_function_trace(const char * fmt, ...);

// Errors are reported to message box, the function_trace file, both or neither
void ap238_report_error(const char * fmt, ...);

// include and definitions for save_all_milling_tools ()
#include "ToolMaker.h"
int save_all_milling_tools (RoseDesign *des, unsigned &tool_count, Milling_machine_cutting_tool_IF *step_tools[], tp_tool mastercam_tools[]);

// include and definitions for save_all_operations
#include "OperationMaker.h"

int save_all_milling_operations (Workplan *plan, unsigned tool_count, Milling_machine_cutting_tool_IF *step_tools[], tp_tool mastercam_tools[]);
int save_ws_toolpaths (Machining_workingstep *ws, operation *op, unsigned tool_count, Milling_machine_cutting_tool_IF *step_tools[], tp_tool mastercam_tools[]);

void GetOpParents(operation *opl, CStringArray *names);


#endif